#include "qwayland-hawaii.h"

QT_BEGIN_NAMESPACE

namespace QtWayland {
    hawaii_shell::hawaii_shell(struct ::wl_registry *registry, int id)
    {
        init(registry, id);
    }

    hawaii_shell::hawaii_shell(struct ::hawaii_shell *obj)
        : m_hawaii_shell(obj)
    {
        init_listener();
    }

    hawaii_shell::hawaii_shell()
        : m_hawaii_shell(0)
    {
    }

    hawaii_shell::~hawaii_shell()
    {
    }

    void hawaii_shell::init(struct ::wl_registry *registry, int id)
    {
        m_hawaii_shell = static_cast<struct ::hawaii_shell *>(wl_registry_bind(registry, id, &hawaii_shell_interface, 1));
        init_listener();
    }

    void hawaii_shell::init(struct ::hawaii_shell *obj)
    {
        m_hawaii_shell = obj;
        init_listener();
    }

    bool hawaii_shell::isInitialized() const
    {
        return m_hawaii_shell != 0;
    }

    void hawaii_shell::add_trusted_client(int32_t fd, const QString &interface)
    {
        hawaii_shell_add_trusted_client(
            m_hawaii_shell,
            fd,
            interface.toUtf8().constData());
    }

    struct ::hawaii_key_binding *hawaii_shell::add_key_binding(uint32_t key, uint32_t modifiers)
    {
        return hawaii_shell_add_key_binding(
            m_hawaii_shell,
            key,
            modifiers);
    }

    void hawaii_shell::set_background(struct ::wl_output *output, struct ::wl_surface *surface)
    {
        hawaii_shell_set_background(
            m_hawaii_shell,
            output,
            surface);
    }

    void hawaii_shell::set_desktop(struct ::wl_output *output, struct ::wl_surface *surface)
    {
        hawaii_shell_set_desktop(
            m_hawaii_shell,
            output,
            surface);
    }

    void hawaii_shell::set_config_surface(struct ::wl_output *output, struct ::wl_surface *surface)
    {
        hawaii_shell_set_config_surface(
            m_hawaii_shell,
            output,
            surface);
    }

    void hawaii_shell::set_overlay(struct ::wl_surface *surface)
    {
        hawaii_shell_set_overlay(
            m_hawaii_shell,
            surface);
    }

    void hawaii_shell::set_lock_surface(struct ::wl_surface *surface)
    {
        hawaii_shell_set_lock_surface(
            m_hawaii_shell,
            surface);
    }

    void hawaii_shell::set_grab_surface(struct ::wl_surface *surface)
    {
        hawaii_shell_set_grab_surface(
            m_hawaii_shell,
            surface);
    }

    void hawaii_shell::set_position(struct ::wl_surface *surface, int32_t x, int32_t y)
    {
        hawaii_shell_set_position(
            m_hawaii_shell,
            surface,
            x,
            y);
    }

    void hawaii_shell::quit()
    {
        hawaii_shell_quit(
            m_hawaii_shell);
    }

    void hawaii_shell::lock()
    {
        hawaii_shell_lock(
            m_hawaii_shell);
    }

    void hawaii_shell::unlock()
    {
        hawaii_shell_unlock(
            m_hawaii_shell);
    }

    void hawaii_shell::desktop_ready()
    {
        hawaii_shell_desktop_ready(
            m_hawaii_shell);
    }

    void hawaii_shell::minimize_windows()
    {
        hawaii_shell_minimize_windows(
            m_hawaii_shell);
    }

    void hawaii_shell::restore_windows()
    {
        hawaii_shell_restore_windows(
            m_hawaii_shell);
    }

    void hawaii_shell::add_workspace()
    {
        hawaii_shell_add_workspace(
            m_hawaii_shell);
    }

    void hawaii_shell::select_workspace(struct ::hawaii_workspace *workspace)
    {
        hawaii_shell_select_workspace(
            m_hawaii_shell,
            workspace);
    }

    void hawaii_shell::shell_loaded()
    {
    }

    void hawaii_shell::handle_loaded(
        void *data,
        struct ::hawaii_shell *object)
    {
        Q_UNUSED(object);
        static_cast<hawaii_shell *>(data)->shell_loaded();
    }

    void hawaii_shell::shell_configure(struct ::wl_surface *, int32_t , int32_t )
    {
    }

    void hawaii_shell::handle_configure(
        void *data,
        struct ::hawaii_shell *object,
        struct ::wl_surface *surface,
        int32_t width,
        int32_t height)
    {
        Q_UNUSED(object);
        static_cast<hawaii_shell *>(data)->shell_configure(
            surface,
            width,
            height);
    }

    void hawaii_shell::shell_prepare_lock_surface()
    {
    }

    void hawaii_shell::handle_prepare_lock_surface(
        void *data,
        struct ::hawaii_shell *object)
    {
        Q_UNUSED(object);
        static_cast<hawaii_shell *>(data)->shell_prepare_lock_surface();
    }

    void hawaii_shell::shell_grab_cursor(uint32_t )
    {
    }

    void hawaii_shell::handle_grab_cursor(
        void *data,
        struct ::hawaii_shell *object,
        uint32_t cursor)
    {
        Q_UNUSED(object);
        static_cast<hawaii_shell *>(data)->shell_grab_cursor(
            cursor);
    }

    void hawaii_shell::shell_window_mapped(struct ::hawaii_window *, const QString &, const QString &, int32_t )
    {
    }

    void hawaii_shell::handle_window_mapped(
        void *data,
        struct ::hawaii_shell *object,
        struct ::hawaii_window *id,
        const char *title,
        const char *identifier,
        int32_t state)
    {
        Q_UNUSED(object);
        static_cast<hawaii_shell *>(data)->shell_window_mapped(
            id,
            QString::fromUtf8(title),
            QString::fromUtf8(identifier),
            state);
    }

    void hawaii_shell::shell_window_switching_started()
    {
    }

    void hawaii_shell::handle_window_switching_started(
        void *data,
        struct ::hawaii_shell *object)
    {
        Q_UNUSED(object);
        static_cast<hawaii_shell *>(data)->shell_window_switching_started();
    }

    void hawaii_shell::shell_window_switching_finished()
    {
    }

    void hawaii_shell::handle_window_switching_finished(
        void *data,
        struct ::hawaii_shell *object)
    {
        Q_UNUSED(object);
        static_cast<hawaii_shell *>(data)->shell_window_switching_finished();
    }

    void hawaii_shell::shell_window_switched(struct ::hawaii_window *)
    {
    }

    void hawaii_shell::handle_window_switched(
        void *data,
        struct ::hawaii_shell *object,
        struct ::hawaii_window *window)
    {
        Q_UNUSED(object);
        static_cast<hawaii_shell *>(data)->shell_window_switched(
            window);
    }

    void hawaii_shell::shell_workspace_added(struct ::hawaii_workspace *, int32_t )
    {
    }

    void hawaii_shell::handle_workspace_added(
        void *data,
        struct ::hawaii_shell *object,
        struct ::hawaii_workspace *workspace,
        int32_t active)
    {
        Q_UNUSED(object);
        static_cast<hawaii_shell *>(data)->shell_workspace_added(
            workspace,
            active);
    }

    const struct hawaii_shell_listener hawaii_shell::m_hawaii_shell_listener = {
        hawaii_shell::handle_loaded,
        hawaii_shell::handle_configure,
        hawaii_shell::handle_prepare_lock_surface,
        hawaii_shell::handle_grab_cursor,
        hawaii_shell::handle_window_mapped,
        hawaii_shell::handle_window_switching_started,
        hawaii_shell::handle_window_switching_finished,
        hawaii_shell::handle_window_switched,
        hawaii_shell::handle_workspace_added
    };

    void hawaii_shell::init_listener()
    {
        hawaii_shell_add_listener(m_hawaii_shell, &m_hawaii_shell_listener, this);
    }

    hawaii_panel_manager::hawaii_panel_manager(struct ::wl_registry *registry, int id)
    {
        init(registry, id);
    }

    hawaii_panel_manager::hawaii_panel_manager(struct ::hawaii_panel_manager *obj)
        : m_hawaii_panel_manager(obj)
    {
    }

    hawaii_panel_manager::hawaii_panel_manager()
        : m_hawaii_panel_manager(0)
    {
    }

    hawaii_panel_manager::~hawaii_panel_manager()
    {
    }

    void hawaii_panel_manager::init(struct ::wl_registry *registry, int id)
    {
        m_hawaii_panel_manager = static_cast<struct ::hawaii_panel_manager *>(wl_registry_bind(registry, id, &hawaii_panel_manager_interface, 1));
    }

    void hawaii_panel_manager::init(struct ::hawaii_panel_manager *obj)
    {
        m_hawaii_panel_manager = obj;
    }

    bool hawaii_panel_manager::isInitialized() const
    {
        return m_hawaii_panel_manager != 0;
    }

    struct ::hawaii_panel *hawaii_panel_manager::set_panel(struct ::wl_surface *surface)
    {
        return hawaii_panel_manager_set_panel(
            m_hawaii_panel_manager,
            surface);
    }

    hawaii_panel::hawaii_panel(struct ::wl_registry *registry, int id)
    {
        init(registry, id);
    }

    hawaii_panel::hawaii_panel(struct ::hawaii_panel *obj)
        : m_hawaii_panel(obj)
    {
        init_listener();
    }

    hawaii_panel::hawaii_panel()
        : m_hawaii_panel(0)
    {
    }

    hawaii_panel::~hawaii_panel()
    {
    }

    void hawaii_panel::init(struct ::wl_registry *registry, int id)
    {
        m_hawaii_panel = static_cast<struct ::hawaii_panel *>(wl_registry_bind(registry, id, &hawaii_panel_interface, 1));
        init_listener();
    }

    void hawaii_panel::init(struct ::hawaii_panel *obj)
    {
        m_hawaii_panel = obj;
        init_listener();
    }

    bool hawaii_panel::isInitialized() const
    {
        return m_hawaii_panel != 0;
    }

    void hawaii_panel::set_alignment(uint32_t alignment)
    {
        hawaii_panel_set_alignment(
            m_hawaii_panel,
            alignment);
    }

    void hawaii_panel::set_offset(uint32_t offset)
    {
        hawaii_panel_set_offset(
            m_hawaii_panel,
            offset);
    }

    void hawaii_panel::set_thickness(uint32_t thickness)
    {
        hawaii_panel_set_thickness(
            m_hawaii_panel,
            thickness);
    }

    void hawaii_panel::set_length(uint32_t length)
    {
        hawaii_panel_set_length(
            m_hawaii_panel,
            length);
    }

    void hawaii_panel::set_min_length(uint32_t min_length)
    {
        hawaii_panel_set_min_length(
            m_hawaii_panel,
            min_length);
    }

    void hawaii_panel::set_max_length(uint32_t max_length)
    {
        hawaii_panel_set_max_length(
            m_hawaii_panel,
            max_length);
    }

    void hawaii_panel::dock(uint32_t edge, struct ::wl_output *output)
    {
        hawaii_panel_dock(
            m_hawaii_panel,
            edge,
            output);
    }

    void hawaii_panel::panel_docked()
    {
    }

    void hawaii_panel::handle_docked(
        void *data,
        struct ::hawaii_panel *object)
    {
        Q_UNUSED(object);
        static_cast<hawaii_panel *>(data)->panel_docked();
    }

    const struct hawaii_panel_listener hawaii_panel::m_hawaii_panel_listener = {
        hawaii_panel::handle_docked
    };

    void hawaii_panel::init_listener()
    {
        hawaii_panel_add_listener(m_hawaii_panel, &m_hawaii_panel_listener, this);
    }

    hawaii_shell_surface::hawaii_shell_surface(struct ::wl_registry *registry, int id)
    {
        init(registry, id);
    }

    hawaii_shell_surface::hawaii_shell_surface(struct ::hawaii_shell_surface *obj)
        : m_hawaii_shell_surface(obj)
    {
    }

    hawaii_shell_surface::hawaii_shell_surface()
        : m_hawaii_shell_surface(0)
    {
    }

    hawaii_shell_surface::~hawaii_shell_surface()
    {
    }

    void hawaii_shell_surface::init(struct ::wl_registry *registry, int id)
    {
        m_hawaii_shell_surface = static_cast<struct ::hawaii_shell_surface *>(wl_registry_bind(registry, id, &hawaii_shell_surface_interface, 1));
    }

    void hawaii_shell_surface::init(struct ::hawaii_shell_surface *obj)
    {
        m_hawaii_shell_surface = obj;
    }

    bool hawaii_shell_surface::isInitialized() const
    {
        return m_hawaii_shell_surface != 0;
    }

    struct ::hawaii_popup_surface *hawaii_shell_surface::set_popup(struct ::wl_surface *parent, struct ::wl_surface *surface, int32_t x, int32_t y)
    {
        return hawaii_shell_surface_set_popup(
            m_hawaii_shell_surface,
            parent,
            surface,
            x,
            y);
    }

    void hawaii_shell_surface::set_dialog(struct ::wl_output *output, struct ::wl_surface *surface)
    {
        hawaii_shell_surface_set_dialog(
            m_hawaii_shell_surface,
            output,
            surface);
    }

    hawaii_popup_surface::hawaii_popup_surface(struct ::wl_registry *registry, int id)
    {
        init(registry, id);
    }

    hawaii_popup_surface::hawaii_popup_surface(struct ::hawaii_popup_surface *obj)
        : m_hawaii_popup_surface(obj)
    {
        init_listener();
    }

    hawaii_popup_surface::hawaii_popup_surface()
        : m_hawaii_popup_surface(0)
    {
    }

    hawaii_popup_surface::~hawaii_popup_surface()
    {
    }

    void hawaii_popup_surface::init(struct ::wl_registry *registry, int id)
    {
        m_hawaii_popup_surface = static_cast<struct ::hawaii_popup_surface *>(wl_registry_bind(registry, id, &hawaii_popup_surface_interface, 1));
        init_listener();
    }

    void hawaii_popup_surface::init(struct ::hawaii_popup_surface *obj)
    {
        m_hawaii_popup_surface = obj;
        init_listener();
    }

    bool hawaii_popup_surface::isInitialized() const
    {
        return m_hawaii_popup_surface != 0;
    }

    void hawaii_popup_surface::popup_surface_popup_done()
    {
    }

    void hawaii_popup_surface::handle_popup_done(
        void *data,
        struct ::hawaii_popup_surface *object)
    {
        Q_UNUSED(object);
        static_cast<hawaii_popup_surface *>(data)->popup_surface_popup_done();
    }

    const struct hawaii_popup_surface_listener hawaii_popup_surface::m_hawaii_popup_surface_listener = {
        hawaii_popup_surface::handle_popup_done
    };

    void hawaii_popup_surface::init_listener()
    {
        hawaii_popup_surface_add_listener(m_hawaii_popup_surface, &m_hawaii_popup_surface_listener, this);
    }

    hawaii_key_binding::hawaii_key_binding(struct ::wl_registry *registry, int id)
    {
        init(registry, id);
    }

    hawaii_key_binding::hawaii_key_binding(struct ::hawaii_key_binding *obj)
        : m_hawaii_key_binding(obj)
    {
        init_listener();
    }

    hawaii_key_binding::hawaii_key_binding()
        : m_hawaii_key_binding(0)
    {
    }

    hawaii_key_binding::~hawaii_key_binding()
    {
    }

    void hawaii_key_binding::init(struct ::wl_registry *registry, int id)
    {
        m_hawaii_key_binding = static_cast<struct ::hawaii_key_binding *>(wl_registry_bind(registry, id, &hawaii_key_binding_interface, 1));
        init_listener();
    }

    void hawaii_key_binding::init(struct ::hawaii_key_binding *obj)
    {
        m_hawaii_key_binding = obj;
        init_listener();
    }

    bool hawaii_key_binding::isInitialized() const
    {
        return m_hawaii_key_binding != 0;
    }

    void hawaii_key_binding::key_binding_triggered()
    {
    }

    void hawaii_key_binding::handle_triggered(
        void *data,
        struct ::hawaii_key_binding *object)
    {
        Q_UNUSED(object);
        static_cast<hawaii_key_binding *>(data)->key_binding_triggered();
    }

    const struct hawaii_key_binding_listener hawaii_key_binding::m_hawaii_key_binding_listener = {
        hawaii_key_binding::handle_triggered
    };

    void hawaii_key_binding::init_listener()
    {
        hawaii_key_binding_add_listener(m_hawaii_key_binding, &m_hawaii_key_binding_listener, this);
    }

    hawaii_window::hawaii_window(struct ::wl_registry *registry, int id)
    {
        init(registry, id);
    }

    hawaii_window::hawaii_window(struct ::hawaii_window *obj)
        : m_hawaii_window(obj)
    {
        init_listener();
    }

    hawaii_window::hawaii_window()
        : m_hawaii_window(0)
    {
    }

    hawaii_window::~hawaii_window()
    {
    }

    void hawaii_window::init(struct ::wl_registry *registry, int id)
    {
        m_hawaii_window = static_cast<struct ::hawaii_window *>(wl_registry_bind(registry, id, &hawaii_window_interface, 1));
        init_listener();
    }

    void hawaii_window::init(struct ::hawaii_window *obj)
    {
        m_hawaii_window = obj;
        init_listener();
    }

    bool hawaii_window::isInitialized() const
    {
        return m_hawaii_window != 0;
    }

    void hawaii_window::set_state(int32_t state)
    {
        hawaii_window_set_state(
            m_hawaii_window,
            state);
    }

    void hawaii_window::close()
    {
        hawaii_window_close(
            m_hawaii_window);
    }

    void hawaii_window::window_title_changed(const QString &)
    {
    }

    void hawaii_window::handle_title_changed(
        void *data,
        struct ::hawaii_window *object,
        const char *title)
    {
        Q_UNUSED(object);
        static_cast<hawaii_window *>(data)->window_title_changed(
            QString::fromUtf8(title));
    }

    void hawaii_window::window_identifier_changed(const QString &)
    {
    }

    void hawaii_window::handle_identifier_changed(
        void *data,
        struct ::hawaii_window *object,
        const char *identifier)
    {
        Q_UNUSED(object);
        static_cast<hawaii_window *>(data)->window_identifier_changed(
            QString::fromUtf8(identifier));
    }

    void hawaii_window::window_state_changed(int32_t )
    {
    }

    void hawaii_window::handle_state_changed(
        void *data,
        struct ::hawaii_window *object,
        int32_t state)
    {
        Q_UNUSED(object);
        static_cast<hawaii_window *>(data)->window_state_changed(
            state);
    }

    void hawaii_window::window_unmapped()
    {
    }

    void hawaii_window::handle_unmapped(
        void *data,
        struct ::hawaii_window *object)
    {
        Q_UNUSED(object);
        static_cast<hawaii_window *>(data)->window_unmapped();
    }

    const struct hawaii_window_listener hawaii_window::m_hawaii_window_listener = {
        hawaii_window::handle_title_changed,
        hawaii_window::handle_identifier_changed,
        hawaii_window::handle_state_changed,
        hawaii_window::handle_unmapped
    };

    void hawaii_window::init_listener()
    {
        hawaii_window_add_listener(m_hawaii_window, &m_hawaii_window_listener, this);
    }

    hawaii_workspace::hawaii_workspace(struct ::wl_registry *registry, int id)
    {
        init(registry, id);
    }

    hawaii_workspace::hawaii_workspace(struct ::hawaii_workspace *obj)
        : m_hawaii_workspace(obj)
    {
        init_listener();
    }

    hawaii_workspace::hawaii_workspace()
        : m_hawaii_workspace(0)
    {
    }

    hawaii_workspace::~hawaii_workspace()
    {
    }

    void hawaii_workspace::init(struct ::wl_registry *registry, int id)
    {
        m_hawaii_workspace = static_cast<struct ::hawaii_workspace *>(wl_registry_bind(registry, id, &hawaii_workspace_interface, 1));
        init_listener();
    }

    void hawaii_workspace::init(struct ::hawaii_workspace *obj)
    {
        m_hawaii_workspace = obj;
        init_listener();
    }

    bool hawaii_workspace::isInitialized() const
    {
        return m_hawaii_workspace != 0;
    }

    void hawaii_workspace::remove()
    {
        hawaii_workspace_remove(
            m_hawaii_workspace);
    }

    void hawaii_workspace::workspace_activated()
    {
    }

    void hawaii_workspace::handle_activated(
        void *data,
        struct ::hawaii_workspace *object)
    {
        Q_UNUSED(object);
        static_cast<hawaii_workspace *>(data)->workspace_activated();
    }

    void hawaii_workspace::workspace_deactivated()
    {
    }

    void hawaii_workspace::handle_deactivated(
        void *data,
        struct ::hawaii_workspace *object)
    {
        Q_UNUSED(object);
        static_cast<hawaii_workspace *>(data)->workspace_deactivated();
    }

    const struct hawaii_workspace_listener hawaii_workspace::m_hawaii_workspace_listener = {
        hawaii_workspace::handle_activated,
        hawaii_workspace::handle_deactivated
    };

    void hawaii_workspace::init_listener()
    {
        hawaii_workspace_add_listener(m_hawaii_workspace, &m_hawaii_workspace_listener, this);
    }
}

QT_END_NAMESPACE
