/****************************************************************************
 * This file is part of Hawaii Shell.
 *
 * Copyright (C) 2013-2014 Pier Luigi Fiorini <pierluigi.fiorini@gmail.com>
 *
 * Author(s):
 *    Pier Luigi Fiorini
 *
 * $BEGIN_LICENSE:GPL2+$
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * $END_LICENSE$
 ***************************************************************************/

#ifndef WORKSPACE_H
#define WORKSPACE_H

#include <QtCore/QObject>

class ShellClient;
class ShellController;
class WorkspacePrivate;

class Workspace : public QObject
{
    Q_OBJECT
    Q_PROPERTY(bool active READ isActive NOTIFY activeChanged)
    Q_DISABLE_COPY(Workspace)
    Q_DECLARE_PRIVATE(Workspace)
public:
    Workspace(bool active, QObject *parent = 0);

    bool isActive() const;

Q_SIGNALS:
    void activeChanged(bool value);

public Q_SLOTS:
    void activate();

private:
    friend class ShellClient;
    friend class ShellController;

    WorkspacePrivate *const d_ptr;
};

#endif // WORKSPACE_H
