#ifndef NOTIFICATION_CLIENT_PROTOCOL_H
#define NOTIFICATION_CLIENT_PROTOCOL_H

#ifdef  __cplusplus
extern "C" {
#endif

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

struct wl_client;
struct wl_resource;

struct wl_notification_daemon;

extern const struct wl_interface wl_notification_daemon_interface;

#define WL_NOTIFICATION_DAEMON_ADD_SURFACE	0

static inline void
wl_notification_daemon_set_user_data(struct wl_notification_daemon *wl_notification_daemon, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) wl_notification_daemon, user_data);
}

static inline void *
wl_notification_daemon_get_user_data(struct wl_notification_daemon *wl_notification_daemon)
{
	return wl_proxy_get_user_data((struct wl_proxy *) wl_notification_daemon);
}

static inline void
wl_notification_daemon_destroy(struct wl_notification_daemon *wl_notification_daemon)
{
	wl_proxy_destroy((struct wl_proxy *) wl_notification_daemon);
}

static inline void
wl_notification_daemon_add_surface(struct wl_notification_daemon *wl_notification_daemon, struct wl_surface *surface)
{
	wl_proxy_marshal((struct wl_proxy *) wl_notification_daemon,
			 WL_NOTIFICATION_DAEMON_ADD_SURFACE, surface);
}

#ifdef  __cplusplus
}
#endif

#endif
