/* 
 * Copyright (C) 2013 Pier Luigi Fiorini
 * Copyright (C) 2011 Pekka Paalanen
 * 
 * Permission to use, copy, modify, distribute, and sell this
 * software and its documentation for any purpose is hereby granted
 * without fee, provided that the above copyright notice appear in
 * all copies and that both that copyright notice and this permission
 * notice appear in supporting documentation, and that the name of
 * the copyright holders not be used in advertising or publicity
 * pertaining to distribution of the software without specific,
 * written prior permission.  The copyright holders make no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied
 * warranty.
 * 
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
 * THIS SOFTWARE.
 */

#ifndef SCREENSAVER_CLIENT_PROTOCOL_H
#define SCREENSAVER_CLIENT_PROTOCOL_H

#ifdef  __cplusplus
extern "C" {
#endif

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

struct wl_client;
struct wl_resource;

struct wl_screensaver;

extern const struct wl_interface wl_screensaver_interface;

#define WL_SCREENSAVER_SET_SURFACE	0

static inline void
wl_screensaver_set_user_data(struct wl_screensaver *wl_screensaver, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) wl_screensaver, user_data);
}

static inline void *
wl_screensaver_get_user_data(struct wl_screensaver *wl_screensaver)
{
	return wl_proxy_get_user_data((struct wl_proxy *) wl_screensaver);
}

static inline void
wl_screensaver_destroy(struct wl_screensaver *wl_screensaver)
{
	wl_proxy_destroy((struct wl_proxy *) wl_screensaver);
}

static inline void
wl_screensaver_set_surface(struct wl_screensaver *wl_screensaver, struct wl_output *output, struct wl_surface *surface)
{
	wl_proxy_marshal((struct wl_proxy *) wl_screensaver,
			 WL_SCREENSAVER_SET_SURFACE, output, surface);
}

#ifdef  __cplusplus
}
#endif

#endif
